--[[
	Hands Warrior: Arms are worthless without hands
	For now, maybe forever, this is all hard-coded.
	It's *kind of* specific: one thing checks for
		a debuff, two check for a buff, some check
		just for cooldowns, one checks mob HP...
	Some kind of "flow chart system" would be cool.
	Another project for another day.
	
	For the logic you can look at the code at bottom
	Basically
		Rend takes priority but don't refresh early
		If we have SD, execute
		If MS is off CD and >= 35 rage, MS
		If we have TfB, overpower
		If MS is off CD and low rage, save for MS
		Otherwise slam.
]]
--SLASH_RL1 = "/rl" SlashCmdList["RL"] = function() ReloadUI() end

-------------------------------------------------
-- Gather spell data
-- TODO: This feels sloppy. :(
-------------------------------------------------
 rot = {
	-- this can't be verbose for... simplicity's sake. yeah.
	[0] = { id = 694 }, -- Uh, Mocking Blow?
	[1] = { id = 47465 }, -- Rend
	[2] = { id = 47486 }, -- MS
	[3] = { id = 47471 }, -- Execute
	[4] = { id = 7384  }, -- Overpower
	[5] = { id = 47475 }, -- Slam
	--[2] = { id = 23881 }, -- Bloodthirst (for testing)
}
for pos, d in pairs(rot) do
	local name,_, icon = GetSpellInfo(d.id)
	rot[pos].name = name
	rot[pos].icon = icon
end
local i = 1
while true do
	local spell = GetSpellName(i, BOOKTYPE_SPELL)
	if not spell then break end
	for pos, d in pairs(rot) do
		if spell == d.name then
			rot[pos].slot = i
		end
	end
	i = i + 1
end
local buffs = {
	TfB = GetSpellInfo(60503),
	SuddenDeath = GetSpellInfo(52437),
}
	

-------------------------------------------------
-- Create the main frame
-------------------------------------------------
local HWf = CreateFrame("Frame", nil, UIParent)
HWf:SetFrameStrata("BACKGROUND")
HWf:SetWidth(92)
HWf:SetHeight(116)
-- Backdrop/LnF stuff
HWf:SetBackdrop({
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	tile = false, tileSize = 0, edgeSize = 16,
	insets = { left=4,right=4,top=4,bottom=4 }
})
HWf:SetBackdropColor(0,0,0,.8)
-- Responsive dragging
HWf:SetMovable(true)
HWf:EnableMouse(true)
HWf:SetScript("OnMouseDown", function()
	if ((not this.isLocked) or this.isLocked == 0) and arg1 == "LeftButton" then
		this:StartMoving()
		this.isMoving = true
	end
end)
local s = function(t)
	if t.isMoving then t:StopMovingOrSizing() t.isMoving = false end end
HWf:SetScript("OnMouseUp", function() s(this) end)
HWf:SetScript("OnHide", function() s(this) end)
-- Go, captain planet!
HWf:SetPoint("CENTER", 0, 0)
HWf:Show()

-------------------------------------------------
-- Create the active icon
-------------------------------------------------
HWi = CreateFrame("Button", nil, HWf)
HWi:SetPoint("TOPLEFT", 6, -26)
HWi:SetPoint("BOTTOMRIGHT", -6, 6)
HWi:SetScript("OnEnter", function()
	if not HWf.spell then return end
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent)
	GameTooltip:SetSpell(rot[HWf.spell].slot, BOOKTYPE_SPELL)
	GameTooltip:Show()
end)
HWi:SetScript("OnLeave", function() GameTooltip:Hide() end)
-- We have to set this to move the parent frame
-- There is no click through option that preserves
-- the ability to mouseover AFAIK
HWi:SetScript("OnMouseDown", function()
	if ((not HWf.isLocked) or HWf.isLocked == 0) and arg1 == "LeftButton" then
		HWf:StartMoving()
		HWf.isMoving = true
	end
end)
HWi:SetScript("OnMouseUp", function() s(HWf) end)
HWi:SetScript("OnHide", function() s(HWf) end)

-------------------------------------------------
-- Create the font text string
-------------------------------------------------
HWt = HWf:CreateFontString(nil,nil,"GameFontNormal")
HWt:SetPoint("TOPLEFT", 6, -8)
HWt:SetPoint("TOPRIGHT", -6, -8)
HWt:SetJustifyH("CENTER")

-------------------------------------------------
-- Helper functions
-------------------------------------------------
local function HWSpell(id)
	if not rot[id] then DEFAULT_CHAT_FRAME:AddMessage("what the hell are you doing") return end
	if not rot[id].slot then return end
	HWf.spell = id
	HWi:SetNormalTexture(rot[id].icon)
	HWt:SetText(rot[id].name)
end
SlashCmdList["HWS"] = function(a) HWSpell(tonumber(a)) end
SLASH_HWS1 = "/hws"
HWSpell(1)
local function HWDebug(msg)
	DEFAULT_CHAT_FRAME:AddMessage("|cffff8888Hands|cffc79c6eWarrior|r: " .. msg)
end

-------------------------------------------------
-- The magic begins (s/ma/lo/)
-------------------------------------------------
HWf.lastUpdate = 0
HWf:SetScript("OnUpdate", function()
	this.lastUpdate = this.lastUpdate + arg1
	if this.lastUpdate > .2 then
		if not UnitExists("target") then HWSpell(0) end
		-- This is all self-explanitory logic. Almost.
		-- OK, I'll explain some of it.
		-- First of all, rend should be up all the time.
		-- We don't want to refresh it early though.
		if not UnitDebuff("target", rot[1].name) then HWSpell(1) -- Rend
		else
			-- Otherwise, execute is > MS
			if UnitBuff("player", buffs.SuddenDeath) then HWSpell(3) -- Exec
			else
				-- We're being wierd here.
				-- If less than 35 rage, we don't want to MS
				-- UNLESS we can't overpower.
				-- Basically, MS > Slam, but, with low rage, OP > MS (5 vs 30R)
				local MSCD = select(2,GetSpellCooldown(rot[2].slot, BOOKTYPE_SPELL))
				if MSCD < 2 and UnitMana("player") > 35 then HWSpell(2) -- MS
				else
					if UnitBuff("player", buffs.TfB) then HWSpell(4) -- OP
					else
						if MSCD < 2 then HWSpell(2)
						else HWSpell(5) -- Slam
						end
					end
				end
			end
		end
		
		this.lastUpdate = 0
	end
end)